// Copyright 2005 DJ Delorie
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "logger.h"

LogEvent le;

void
zone(int z, int t, int h, int v)
{
  printf("[%d %4.1fF %4.1f%%%s] ",
	 z, t/100.0, h/2.0, v ? " Z" : " -");
}

int
main(int argc, char **argv)
{
  int i;

  for (i=1; i<argc; i++)
    {
      printf("[%s]\n", argv[i]);
      FILE *f = fopen(argv[i], "rb");
      if (!f)
	perror(argv[i]);
      while (fread(&le, 1, sizeof(le), f) == sizeof(le))
	{
	  struct tm *tm = localtime((time_t *)&le.time);
	  printf("%02d:%02d:%02d ", tm->tm_hour, tm->tm_min, tm->tm_sec);
	  zone(0, le.temp[0], le.humidity[0], le.furnace.zone0);
	  zone(1, le.temp[1], le.humidity[1], le.furnace.zone1);
	  zone(2, le.temp[2], le.humidity[2], le.furnace.zone2);
	  zone(3, le.temp[3], le.humidity[3], le.furnace.zone3);
	  printf("%c %c %c %c\n",
		 le.furnace.heat ? 'H' : '-',
		 le.furnace.cool ? 'C' : '-',
		 le.furnace.fan ? 'F' : '-',
		 le.furnace.humidify ? 'W' : '-');
	}
      fclose(f);
    }
  exit(0);
}
