// Copyright 2005 DJ Delorie
#include "msgtypes.h"

class Message {
  int my_data;
 public:
  int source;
  int dest;
  MsgType type;
  unsigned char *data;
  int length; // of data, not alldata

  Message(int length, MsgType mtype);
  Message(const void *data, int length, MsgType mtype);
  ~Message();

  static int mux_socket (void);
  static void set_my_name(const char *);
  static const char *get_name_for(int id);
  static void set_snoop(int on);
  static void set_host(const char *hostname);

  void send(void);

  static void init(void);

  // wait is milliseconds; -1 means forever, 0 means poll.  Note that
  // the returned value is reused from call to call; do not delete it.
  static Message *next(int waitms = -1);

  // Forces next() to return NULL at a point in the future, not more
  // than msec milliseconds from now.  It may be sooner.  Default
  // disables alarm.
  static void set_alarm(int msec_from_now=-1);
};
