// Copyright 2005 DJ Delorie
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "msg.h"
#include "furnace.h"

int
main(int argc, char **argv)
{
  char *name = argc > 1 ? argv[1] : 0;
  char *valstr = argc > 2 ? argv[2] : (char *)"";
  FurnaceData fd;
  char lcd[100];
  Message *m;
  int i;

  Message::set_my_name("set-furn");
  Message::init();

  if (!name)
    exit(0);

  memset(&fd, 0, sizeof(fd));

  if (name[0] == 'l')
    {
      lcd[0] = name[1] - '0';
      strcpy (lcd+1, valstr);
      Message lcdm(lcd, 1+strlen(lcd+1), MT_lcd);
      lcdm.send();
      exit(0);
    }

  for (i=0; name[i]; i++)
    {
      switch (name[i])
	{
	case 'h': fd.heat = 1; break;
	case 'c': fd.cool = 1; break;
	case 'f': fd.fan = 1; break;
	case 'm': fd.humidify = 1; break;
	case '1': fd.zone[0] = 1; break;
	case '2': fd.zone[1] = 1; break;
	case '3': fd.zone[2] = 1; break;
	case '4': fd.zone[3] = 1; break;
	}
    }

  Message command(&fd, sizeof(fd), MT_set_furnace);
  command.send();
  exit(0);
}
