// Copyright 2005 DJ Delorie
#define VAR_NO_ID 0

// Variables are all of type "double".  This allows up to 53 bit
// signed integers too.

typedef double VarValueType;
struct Message;

struct Var {
  Var *next;
  const char *name;
  int id;
  int multi;
  VarValueType value;

  Var();
  Var(const char *name);
  Var(int zone, const char *name);
  void set_name(const char *name);
  void set_name(int zone, const char *name);

  void set(VarValueType newvalue);

  static void setup_names (void);
  static void wait_for_all_ids (void);
  // msg.cc call this automatically
  static void handle_message(Message *m);

  operator double() { return (double)value; }
};

// Data format for MT_var_id
struct VarIdData {
  int id;
  VarValueType value;
  char name[1]; // really longer
};

// Data format for MT_set_var_value
struct SetVarValueData {
  int id;
  VarValueType value;
};
