// Copyright 2005 DJ Delorie
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "msg.h"
#include "vars.h"

int
main(int argc, char **argv)
{
  while (argc > 1 && argv[1][0] == '-')
    {
      if (argc > 2 && strcmp (argv[1], "-h") == 0)
	{
	  Message::set_host (argv[2]);
	  argv += 2;
	  argc -= 2;
	}
    }

  char *name = argc > 1 ? argv[1] : 0;
  char *valstr = argc > 2 ? argv[2] : 0;

  if (!name)
    exit(0);

  Var *var = new Var(name);

  Message::set_my_name("vartest");
  Message::init();
  Var::wait_for_all_ids();

  if (!valstr)
    {
      printf("%f\n", var->value);
      exit(0);
    }

  double d = strtod (valstr, 0);
  if (var->value != d)
    printf("Changing %s from %g to %g\n", name, var->value, d);
  var->set(d);
  exit(0);
}
